package com.trs.ggzyexchange.config;


import com.trs.ggzyexchange.schedul.*;
import org.quartz.*;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class QuartzConfig {


    /**
     * 定时任务执行的时间
     */
    @Value("${time.cron}")
    private String strSron;

    /**
     * 创建Job实例
     * 定时任务 国有产权 交易结果/实物资产
     */
    @Bean
    public JobDetail jobDetailCqSwBargainResult() {
        return JobBuilder.newJob(CqSwCompleteBulletinSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerCqSwBargainResult() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerCqSwBargainResult", "groupTriggerCqSwBargainResult")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobDetailCqSwBargainResult())
                .build();
    }

    @Bean
    public JobDetail jobDetailCqSwCompleteBulletin() {
        return JobBuilder.newJob(CqSwCompleteBulletinSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerCqSwCompleteBulletin() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerCqSwCompleteBulletin", "groupTriggerCqSwCompleteBulletin")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobDetailCqSwCompleteBulletin())
                .build();
    }

    /**
     * 创建Job实例
     * 定时任务 国有产权  挂牌披露/实物资产
     */
    @Bean
    public JobDetail jobDetailCqSwIssueBulletin() {
        return JobBuilder.newJob(CqSwIssueBulletinSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerCqSwIssueBulletin() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerCqSwIssueBulletin", "groupTriggerCqSwIssueBulletin")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobDetailCqSwIssueBulletin())
                .build();
    }

    /**
     * 创建Job实例
     * 定时任务 工程建设 中标候选人公示
     */
    @Bean
    public JobDetail jobGcBidcandidatePost() {
        return JobBuilder.newJob(GcBidcandidatePostSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerGcBidcandidatePost() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerGcBidcandidatePost", "groupTriggerGcBidcandidatePost")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobGcBidcandidatePost())
                .build();
    }

    /**
     * 创建Job实例
     * 定时任务 工程建设 交易异常公告
     */
    @Bean
    public JobDetail jobGcBidExceptioNoticeSchedul() {
        return JobBuilder.newJob(GcBidExceptioNoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerGcBidExceptioNoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerGcBidExceptioNoticeSchedul", "groupTriggerGcBidExceptioNoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobGcBidExceptioNoticeSchedul())
                .build();
    }


    /**
     * 创建Job实例
     * 定时任务 工程建设 开标记录
     */
    @Bean
    public JobDetail jobGcBidopenrecordSchedul() {
        return JobBuilder.newJob(GcBidopenrecordSchedul.class).storeDurably().build();
    }
    @Bean
    public Trigger triggerGcBidopenrecordSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerGcBidopenrecordSchedul", "groupTriggerGcBidopenrecordSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobGcBidopenrecordSchedul())
                .build();
    }


    /**
     * 创建Job实例
     * 定时任务 工程建设 中标结果公告
     */
    @Bean
    public JobDetail jobGcBidpublicitySchedul() {
        return JobBuilder.newJob(GcBidpublicitySchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerGcBidpublicitySchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerGcBidpublicitySchedul", "groupTriggerGcBidpublicitySchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobGcBidpublicitySchedul())
                .build();
    }

    /**
     * 创建Job实例
     * 定时任务 工程建设 招标公告
     */
    @Bean
    public JobDetail jobGcNoticeandfileSchedul() {
        return JobBuilder.newJob(GcNoticeandfileSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerGcNoticeandfileSchedulSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerGcNoticeandfileSchedulSchedul", "groupTriggerGcNoticeandfileSchedulSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobGcNoticeandfileSchedul())
                .build();
    }


    /**
     * 创建Job实例
     * 定时任务 工程建设 履约公示
     */
    @Bean
    public JobDetail jobGcPerformanceSchedul() {
        return JobBuilder.newJob(GcPerformanceSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerGcPerformanceSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerGcPerformanceSchedul", "groupTriggerGcPerformanceSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobGcPerformanceSchedul())
                .build();
    }


    /**
     * 创建Job实例
     * 定时任务 工程建设 合同公示
     */
    @Bean
    public JobDetail jobGcPubContractSchedul() {
        return JobBuilder.newJob(GcPubContractSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerGcPubContractSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerGcPubContractSchedul", "groupTriggerGcPubContractSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobGcPubContractSchedul())
                .build();
    }


    /**
     * 创建Job实例
     * 定时任务 工程建设 招标文件
     */
    @Bean
    public JobDetail jobGcTenderbidfileSchedul() {
        return JobBuilder.newJob(GcTenderbidfileSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerGcTenderbidfileSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerGcTenderbidfileSchedul", "groupTriggerGcTenderbidfileSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobGcTenderbidfileSchedul())
                .build();
    }


    /**
     * 创建Job实例
     * 定时任务 医疗交易 交易公告
     */
    @Bean
    public JobDetail jobYcNoticeSchedulSchedul() {
        return JobBuilder.newJob(YcNoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerYcNoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerYcNoticeSchedul", "groupTriggerYcNoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobYcNoticeSchedulSchedul())
                .build();
    }

    /**
     * 创建Job实例
     * 定时任务 自然资源 出让公告  出让公告信息
     */
    @Bean
    public JobDetail jobZrzyTdCedeNoticeSchedul() {
        return JobBuilder.newJob(ZrzyTdCedeNoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerZrzyTdCedeNoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerZrzyTdCedeNoticeSchedul", "groupTriggerZrzyTdCedeNoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobZrzyTdCedeNoticeSchedul())
                .build();
    }
    /**
     * 创建Job实例
     * 定时任务 自然资源 出让公告  探矿权招拍挂公告信息
     */
    @Bean
    public JobDetail jobZrzyTkqNoticeSchedul() {
        return JobBuilder.newJob(ZrzyTkqNoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerZrzyTkqNoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerZrzyTkqNoticeSchedul", "groupTriggerZrzyTkqNoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobZrzyTkqNoticeSchedul())
                .build();
    }

    @Bean
    public JobDetail jobZrzyTkqBidwinnoticeSchedul() {
        return JobBuilder.newJob(ZrzyTkqBidwinnoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerZrzyTkqBidwinnoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerZrzyTkqBidwinnoticeSchedul", "groupTriggerZrzyTkqBidwinnoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobZrzyTkqBidwinnoticeSchedul())
                .build();
    }


    /**
     * 创建Job实例
     * 定时任务 自然资源 出让公告  采矿权招拍挂公告信息
     */
    @Bean
    public JobDetail jobZrzyCkqNoticeSchedul() {
        return JobBuilder.newJob(ZrzyCkqNoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerZrzyCkqNoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerZrzyCkqNoticeSchedul", "groupTriggerZrzyCkqNoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobZrzyCkqNoticeSchedul())
                .build();
    }


    /**
     * 创建Job实例
     * 定时任务 自然资源 出让公告 地勘
     */
    @Bean
    public JobDetail jobZrzyDkNoticeSchedul() {
        return JobBuilder.newJob(ZrzyDkNoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerZrzyDkNoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerZrzyDkNoticeSchedul", "groupTriggerZrzyDkNoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobZrzyDkNoticeSchedul())
                .build();
    }


    /**
     * 创建Job实例
     * 定时任务 自然资源 出让公告 补充耕地
     */
    @Bean
    public JobDetail jobZrzyBgNoticeSchedul() {
        return JobBuilder.newJob(ZrzyBgNoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerZrzyBgNoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerZrzyBgNoticeSchedul", "groupTriggerZrzyBgNoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobZrzyBgNoticeSchedul())
                .build();
    }

    /**
     * 创建Job实例
     * 定时任务 自然资源 出让公告 城乡增减
     */
    @Bean
    public JobDetail jobZrzyJyzbNoticeSchedul() {
        return JobBuilder.newJob(ZrzyJyzbNoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerZrzyJyzbNoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerZrzyJyzbNoticeSchedul", "groupTriggerZrzyJyzbNoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobZrzyJyzbNoticeSchedul())
                .build();
    }

    /**
     * 创建Job实例
     * 定时任务 成交宗地/出让结果公告 土地
     */
    @Bean
    public JobDetail jobZrzyTdBidwinnoticeSchedul() {
        return JobBuilder.newJob(ZrzyTdBidwinnoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerZrzyTdBidwinnoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerZrzyTdBidwinnoticeSchedul", "groupTriggerZrzyTdBidwinnoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobZrzyTdBidwinnoticeSchedul())
                .build();
    }

    /**
     * 创建Job实例
     * 定时任务 成交宗地/出让结果公告 采矿权招拍挂结果公示信息
     */
    @Bean
    public JobDetail jobZrzyCkqBidwinnoticeSchedul() {
        return JobBuilder.newJob(ZrzyCkqBidwinnoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerZrzyCkqBidwinnoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerZrzyCkqBidwinnoticeSchedul", "groupTriggerZrzyCkqBidwinnoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobZrzyCkqBidwinnoticeSchedul())
                .build();
    }


    /**
     * 创建Job实例
     * 定时任务 成交宗地/出让结果公告 地勘结果公示信息
     */
    @Bean
    public JobDetail jobZrzyDkBinwinNoticeSchedul() {
        return JobBuilder.newJob(ZrzyDkBinwinNoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerZrzyDkBinwinNoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerZrzyDkBinwinNoticeSchedul", "groupTriggerZrzyDkBinwinNoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobZrzyDkBinwinNoticeSchedul())
                .build();
    }
    /**
     * 创建Job实例
     * 定时任务 成交宗地/出让结果公告 补充耕地结果公示信息
     */
    @Bean
    public JobDetail jobZrzyBgBidwinNoticeSchedul() {
        return JobBuilder.newJob(ZrzyBgBidwinNoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerZrzyBgBidwinNoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerZrzyBgBidwinNoticeSchedul", "groupTriggerZrzyBgBidwinNoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobZrzyBgBidwinNoticeSchedul())
                .build();
    }
    /**
     * 创建Job实例
     * 定时任务 成交宗地/出让结果公告 城乡增减结果公示信息
     */
    @Bean
    public JobDetail jobZrzyJyzbBidwinNoticeSchedul() {
        return JobBuilder.newJob(ZrzyJyzbBidwinNoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerZrzyJyzbBidwinNoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerZrzyJyzbBidwinNoticeSchedul", "groupTriggerZrzyJyzbBidwinNoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobZrzyJyzbBidwinNoticeSchedul())
                .build();
    }

    /**
     * 创建Job实例
     * 定时任务 电力交易 招标公告与资格预审公告 NM_NOTICE
     */
    @Bean
    public JobDetail jobNmNoticeSchedul() {
        return JobBuilder.newJob(NmNoticeSchedul.class).storeDurably().build();
    }
    /**
     * 创建Job实例
     * 定时任务 电力交易 政府采购
     */
    @Bean
    public JobDetail jobZcNoticeSchedul() {
        return JobBuilder.newJob(ZcNoticeSchedul.class).storeDurably().build();
    }

    @Bean
    public JobDetail jobGcJihuaSchedul() {
        return JobBuilder.newJob(GcJihuaSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerNmNoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerNmNoticeSchedul", "groupTriggerNmNoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobNmNoticeSchedul())
                .build();
    }

    @Bean
    public Trigger triggerZcNoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerZcNoticeSchedul", "groupTriggerZcNoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobZcNoticeSchedul())
                .build();
    }
    @Bean
    public Trigger triggerGcJihuaSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerGcJihuaSchedul", "groupTriggerGcJihuaSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobGcJihuaSchedul())
                .build();
    }
    /**
     * 创建Job实例
     * 定时任务 电力交易  中标结果公示 NM_RESULT_NOTICE
     */
    @Bean
    public JobDetail jobNmResultNoticeSchedul() {
        return JobBuilder.newJob(NmResultNoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerNmResultNoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerNmResultNoticeSchedul", "groupTriggerNmResultNoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobNmResultNoticeSchedul())
                .build();
    }

    /**
     * 创建Job实例
     * 定时任务 42、招标文件预公示【GcTenderbidfilepublicity】
     */
    @Bean
    public JobDetail jobGcTenderbidfilepublicitySchedul() {
        return JobBuilder.newJob(GcTenderbidfilepublicitySchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerGcTenderbidfilepublicitySchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerGcTenderbidfilepublicitySchedul", "groupTriggerGcTenderbidfilepublicitySchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobGcTenderbidfilepublicitySchedul())
                .build();
    }

    @Bean
    public JobDetail jobCqcgNoticeandfileSchedul() {
        return JobBuilder.newJob(CqcgNoticeandfileSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerCqcgNoticeandfileSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerCqcgNoticeandfileSchedul", "groupTriggerCqcgNoticeandfileSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobCqcgNoticeandfileSchedul())
                .build();
    }

    @Bean
    public JobDetail jobCqcgChangeFileSchedul() {
        return JobBuilder.newJob(CqcgChangeFileSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerCqcgChangeFileSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerCqcgChangeFileSchedul", "groupTriggerCqcgChangeFileSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobCqcgChangeFileSchedul())
                .build();
    }

    @Bean
    public JobDetail jobCqcgBidcandidatePostSchedul() {
        return JobBuilder.newJob(CqcgBidcandidatePostSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerCqcgBidcandidatePostSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerCqcgBidcandidatePostSchedul", "groupTriggerCqcgBidcandidatePostSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobCqcgBidcandidatePostSchedul())
                .build();
    }

    @Bean
    public JobDetail jobCqcgBidpublicitySchedul() {
        return JobBuilder.newJob(CqcgBidpublicitySchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerCqcgBidpublicitySchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerCqcgBidpublicitySchedul", "groupTriggerCqcgBidpublicitySchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobCqcgBidpublicitySchedul())
                .build();
    }

    @Bean
    public JobDetail jobGcReconsiderSchedul() {
        return JobBuilder.newJob(GcReconsiderSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerGcReconsiderSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerGcReconsiderSchedul", "groupTriggerGcReconsiderSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobGcReconsiderSchedul())
                .build();
    }

    @Bean
    public JobDetail jobZrzySuppleNoticeSchedul() {
        return JobBuilder.newJob(ZrzySuppleNoticeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerZrzySuppleNoticeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerZrzySuppleNoticeSchedul", "groupTriggerZrzySuppleNoticeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobZrzySuppleNoticeSchedul())
                .build();
    }

    @Bean
    public JobDetail jobAllianceCityWebsiteSchedul() {
        return JobBuilder.newJob(AllianceCityWebsiteSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerAllianceCityWebsiteSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerAllianceCityWebsiteSchedul", "groupTriggerAllianceCityWebsiteSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobAllianceCityWebsiteSchedul())
                .build();
    }

    @Bean
    public JobDetail jobMarginReturnCeSchedul() {
        return JobBuilder.newJob(MarginReturnCeSchedul.class).storeDurably().build();
    }
    //触发器
    @Bean
    public Trigger triggerMarginReturnCeSchedul() {
        return TriggerBuilder.newTrigger()
                .withIdentity("triggerMarginReturnCeSchedul", "groupTriggerMarginReturnCeSchedul")
                .withSchedule(CronScheduleBuilder.cronSchedule(this.strSron))
                .forJob(jobMarginReturnCeSchedul())
                .build();
    }

}