package com.trs.ggzyexchange.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * @author trs
 * @since 2023-03-03
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class CqSwCompleteBulletin extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 数据唯一标识（来源系统）
     */
    @TableId("SOURCE_DATA_KEY")
    private String sourceDataKey;

    /**
     * 数据来源系统的编码
     */
    @TableField("SOURCE_DATA_CODE")
    private String sourceDataCode;

    /**
     * 项目名称
     */
    @TableField("PROJECT_NAME")
    private String projectName;

    /**
     * 项目编号
     */
    @TableField("PROJECT_CODE")
    private String projectCode;

    /**
     * 标的编号
     */
    @TableField("BID_CODE")
    private String bidCode;

    /**
     * 标的名称
     */
    @TableField("BID_NAME")
    private String bidName;

    /**
     * 标的物标识码
     */
    @TableField("SYS_OBJECT_ID")
    private String susObjectId;

    /**
     * 统一交易标识码
     */
    @TableField("UNIFIED_DEAL_CODE")
    private String unifiedDealCode;

    /**
     * 项目名称
     */
    @TableField("CONTENT_NAME")
    private String contentName;

    /**
     * 数据内容
     */
    @TableField("CONTENT_DATA")
    private String contentData;

    /**
     * 公告开始时间
     */
    @TableField("CONTENT_START_TIME")
    private Long contentStartTime;

    /**
     * 公告结束时间
     */
    @TableField("CONTENT_END_TIME")
    private Long contentEndTime;

    /**
     * 公告提交时间
     */
    @TableField("BULLETIN_SUBMIT_TIME")
    private Long bulletinSubmitTime;

    /**
     * 交易系统标识码
     */
    @TableField("PLATFORM_CODE")
    private String platformCode;

    /**
     * 交易服务系统标识码
     */
    @TableField("PUB_SERVICE_PLAT_CODE")
    private String pubServicePlatCode;

    /**
     * 数据时间戳
     */
    @TableField("DATA_TIMESTAMP")
    private Long dataTimestamp;

    @TableField(value = "CREATE_DATE", fill = FieldFill.INSERT)
    private Long createDate;

}
