package com.trs.ggzyexchange.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 中标候选人公示
 * </p>
 *
 * @author trs
 * @since 2023-03-04
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class MarginReturnCe extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 数据唯一标识（来源系统）
     */
    @TableId("SOURCE_DATA_KEY")
    private String sourceDataKey;

    /**
     * 数据来源系统的编码
     */
    @TableField("SOURCE_DATA_CODE")
    private String sourceDataCode;

    /**
     * 招标项目编号
     */
    @TableField("TENDER_PROJECT_CODE")
    private String tenderProjectCode;

    /**
     * 相关标段（包）编号
     */
    @TableField("SECTION_CODE")
    private String sectionCode;

    @TableField("BIDDER_NAME")
    private String bidderName;

    @TableField("BIDDER_ORG_CODE")
    private String bidderOrgCode;

    @TableField("IS_NOT_RETURNED")
    private String isNotReturned;

    @TableField("REFUND_TIME")
    private Long refundTime;

    @TableField("REFUND_ACCOUNT_NAME")
    private String refundAccountName;

    @TableField("REFUND_ACCOUNT_CODE")
    private String refundAccountCode;

    @TableField("TRANS_DATE")
    private Long transDate;

    @TableField("NOT_RETURNED_REASONS")
    private String notReturnedReasons;

    @TableField("IS_DEDUCT")
    private String isDeduct;

    @TableField("DEDUCT_AMOUNT")
    private String deductAmount;

    @TableField("REFUND_STATE")
    private String refundState;

    @TableField("DATATIMESTAMP")
    private Long datatimestamp;

    @TableField(value = "CREATE_DATE", fill = FieldFill.INSERT)
    private Long createDate;


}
