package com.trs.ggzyexchange.schedul;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.trs.ggzyexchange.api.vo.Result;
import com.trs.ggzyexchange.controller.AreaDataName;
import com.trs.ggzyexchange.controller.BaseController;
import com.trs.ggzyexchange.entity.*;
import com.trs.ggzyexchange.enums.ClassIfy;
import com.trs.ggzyexchange.enums.JobLock;
import com.trs.ggzyexchange.service.*;
import com.trs.ggzyexchange.utils.TenderDetailsVoUtils;
import org.apache.commons.lang3.ObjectUtils;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 招标异常公告 定时任务
 * </p>
 *
 * @author trs
 * @since 2023-02-16
 */
@Component
public class GcBidExceptioNoticeSchedul implements Job {

    private Logger logger = LoggerFactory.getLogger(GcBidExceptioNoticeSchedul.class);

    @Autowired
    private GcBidExceptioNoticeService gcBidExceptioNoticeService;

    @Autowired
    private AreaDataName areaDataName;

    @Autowired
    private TenderDetailsVoService tenderDetailsVoService;

    @Autowired
    private GcNoticeandfileService gcNoticeandfileService;

    @Autowired
    private ScheduledTashService scheduledTashService;

    @Autowired
    private GcAttachmentService gcAttachmentService;

    public void queryPageListUpdateEs() throws JsonProcessingException {

        /**
         * 查询当前在定时任务表当中的最新时间
         */
        QueryWrapper<ScheduledTash> scheduledTashQueryWrapper = new QueryWrapper<ScheduledTash>();
        scheduledTashQueryWrapper.eq("table_name_value","gc_bid_exceptio_notice");
        Page<ScheduledTash> pageScheduledTash = new Page<ScheduledTash>(1, 1);
        Page<ScheduledTash> page = scheduledTashService.page(pageScheduledTash, scheduledTashQueryWrapper);
        List<ScheduledTash> records = page.getRecords();
        ScheduledTash scheduledTash = null;
        if(records.size() > 0){
            scheduledTash = records.get(0);
        }
        Long time = null;
        if(ObjectUtils.isEmpty(scheduledTash)){
            try {
                /**
                 * 如果scheduledTash为空，证明没有当前定时任务，设置当前的定时任务的时间为0  查询表gcNoticeandfile表当中的最新时间
                 */
                time = gcBidExceptioNoticeService.maxDataTimeStamp();
                ScheduledTash scheduledTashTash = new ScheduledTash();
                scheduledTashTash.setTime(0L);
                time = 0L;
                scheduledTashTash.setTableNameValue("gc_bid_exceptio_notice");
                scheduledTashTash.setUpdateTime(new Date());
                scheduledTashTash.setCreateTime(new Date());
                scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
            }catch (Exception e){
                e.printStackTrace();
            }
        }else {
            /**
             * 如果scheduledTash为空，证明没有当前定时任务，设置当前的定时任务的时间为0  查询表gcNoticeandfile表当中的最新时间
             */
            time = scheduledTash.getTime();
        }
        try {
            //查询表gcNoticeandfile表当中的最新时间
            Long newTime = gcBidExceptioNoticeService.maxDataTimeStamp();
            ScheduledTash scheduledTashTash = new ScheduledTash();
            scheduledTashTash.setTime(newTime);
            scheduledTashTash.setTableNameValue("gc_bid_exceptio_notice");
            scheduledTashTash.setUpdateTime(new Date());
            scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
        }catch (Exception e){
            e.printStackTrace();
        }
        if(!ObjectUtils.isEmpty(time)){
            /**
             * 查询表GcBidExceptioNotice表当中的最新时间，大于ScheduledTash当中的最新时间的数据
             */
            try {
                QueryWrapper<GcBidExceptioNotice> gcBidcandidatePostQueryWrapper = new QueryWrapper<GcBidExceptioNotice>();
                gcBidcandidatePostQueryWrapper.gt("DATA_TIMESTAMP",time);
                int count = gcBidExceptioNoticeService.count(gcBidcandidatePostQueryWrapper);
                Integer pageSize = 1000;
                Integer pageNum = (int)Math.ceil((double)count/pageSize);
                for(int i = 1; i <= pageNum;i++){
                    try {
                        List<TenderDetailsVo> tenderDetailsVoListAll = getTenderDetailsVoListAllByTime(i, pageSize,time);
                        gcNoticeandfileService.parseTenderDetailsVo(tenderDetailsVoListAll);
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
            }catch (Exception e){
                e.printStackTrace();
            }
        }
    }

    public List<TenderDetailsVo> getTenderDetailsVoListAllByTime(Integer pageNo,Integer pageSize,Long time){
        Page<GcBidExceptioNotice> page = new Page<GcBidExceptioNotice>(pageNo, pageSize);
        IPage<TenderDetailsVo> tenderDetailsVoIPage = gcBidExceptioNoticeService.queryGcBidExceptioNoticeAllListByTime(page,time);
        for (TenderDetailsVo record : tenderDetailsVoIPage.getRecords()) {
            record.setNoticeTypeCode(ClassIfy.TRANSACTION_EXCEPTION_ANNOUNCEMENT.getCode());
            record.setNoticeTypeName(ClassIfy.TRANSACTION_EXCEPTION_ANNOUNCEMENT.getName());

            //电力交易
            if(!ObjectUtils.isEmpty(record.getSourceDataCode()) && "7089bc24".equals(record.getSourceDataCode())) {
                record.setTransactionTypeCode(ClassIfy.ELECTRICITY.getCode());
                record.setTransactionTypeName(ClassIfy.ELECTRICITY.getName());
            }else {
                record.setTransactionTypeCode(ClassIfy.ENGINEERING_CONSTRUCTION.getCode());
                record.setTransactionTypeName(ClassIfy.ENGINEERING_CONSTRUCTION.getName());
            }

            record = tenderDetailsVoService.getTenderDetailsVoAllOrther(record);

            try {
                String bidSectionCodes = record.getBidSectionCodes();
                int i1 = bidSectionCodes.indexOf(",");
                int i2 = bidSectionCodes.indexOf(";");
                int i3 = bidSectionCodes.indexOf("<br>");
                int i4 = bidSectionCodes.indexOf("ltbrgt");
                String splitBidSectionCode = null;
                boolean flag = false;
                String[] split = null;
                if(i1 > 0){
                    split =  bidSectionCodes.split(",");
                    flag = true;
                }
                if(i2 > 0){
                    split =  bidSectionCodes.split(";");
                    flag = true;
                }
                if(i3 > 0){
                    split =  bidSectionCodes.split("<br>");
                    flag = true;
                }
                if(i4 > 0){
                    split =  bidSectionCodes.split("ltbrgt");
                    flag = true;
                }
                if(!flag){
                    split = new String[]{bidSectionCodes};
                }
                List<GcAttachment> attachmentList = new ArrayList<GcAttachment>();

                if(record.getDataTimestamp()>20250324000000L){
                    //通过标包编号查询对应的附件信息
                    QueryWrapper<GcAttachment> gcAttachmentQueryWrapper = new QueryWrapper<GcAttachment>();
                    gcAttachmentQueryWrapper.eq("ATTACHMENT_SET_CODE","EXCEPTION_NOTICE_FILE");//add
                    gcAttachmentQueryWrapper.eq("ASSOCIATION_CODE", record.getSourceDataKey());
                    List<GcAttachment> list = gcAttachmentService.list(gcAttachmentQueryWrapper);


                    if(!ObjectUtils.isEmpty(list)){
                        attachmentList.addAll(list);
                    }
                }else{
                    if(!ObjectUtils.isEmpty(split)){
                        if(split.length >=1){
                            for (String bidSectionCode : split) {
                                try {
                                    //通过标包编号查询对应的附件信息
                                    QueryWrapper<GcAttachment> gcAttachmentQueryWrapper = new QueryWrapper<GcAttachment>();
                                    gcAttachmentQueryWrapper.eq("ATTACHMENT_SET_CODE","EXCEPTION_NOTICE_FILE");//add
                                    gcAttachmentQueryWrapper.like("BID_SECTION_CODE",bidSectionCode);
                                    List<GcAttachment> list = gcAttachmentService.list(gcAttachmentQueryWrapper);


                                    if(!ObjectUtils.isEmpty(list)){
                                        attachmentList.addAll(list);
                                    }
                                }catch (Exception e){
                                    e.printStackTrace();
                                }
                            }
                        }
                    }
                }



                String noticeContent = record.getNoticeContent();
                String file = "";
                if(!ObjectUtils.isEmpty(attachmentList)){
                    if(attachmentList.size() > 0){
                        file = "<br>附件：<br>";
                    }
                }
                for (GcAttachment gcAttachment : attachmentList) {
                    try{
                        String attachmentName = gcAttachment.getAttachmentName();
                        String url = gcAttachment.getUrl();
                        file += "<a  target='_blank' style='color: blue' href='"+ url +"'>"+ attachmentName +"</a><br/>";
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
                //招标文件拼接地址
                if(!ObjectUtils.isEmpty(noticeContent) && noticeContent != ""){
                    file = noticeContent + file;
                }
                record.setNoticeContent(file);
            }catch (Exception e){
                e.printStackTrace();
            }

            TenderDetailsVoUtils.isNull(record);
        }
        return tenderDetailsVoIPage.getRecords();
    }

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
       try {
           if(JobLock.GcBidExceptioNoticeFlag){
               JobLock.GcBidExceptioNoticeFlag = false;
               logger.info("执行GcBidExceptioNotice", new SimpleDateFormat().format(new Date()));
               try {
                   queryPageListUpdateEs();
               } catch (JsonProcessingException e) {
                   e.printStackTrace();
               }
               JobLock.GcBidExceptioNoticeFlag = true;
           }else{
               logger.info("不执行GcBidExceptioNotice", new SimpleDateFormat().format(new Date()));
           }
       }catch (Exception e){
           e.printStackTrace();
           JobLock.GcBidExceptioNoticeFlag = true;
       }
    }
}
