package com.trs.ggzyexchange.schedul;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.trs.ggzyexchange.api.vo.Result;
import com.trs.ggzyexchange.controller.AreaDataName;
import com.trs.ggzyexchange.controller.BaseController;
import com.trs.ggzyexchange.entity.*;
import com.trs.ggzyexchange.enums.ClassIfy;
import com.trs.ggzyexchange.enums.JobLock;
import com.trs.ggzyexchange.service.*;
import com.trs.ggzyexchange.utils.TenderDetailsVoUtils;
import org.apache.commons.lang3.ObjectUtils;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 开标记录 定时任务
 * </p>
 *
 * @author trs
 * @since 2023-02-16
 */
@Component
public class GcBidopenrecordSchedul  implements Job {

    private Logger logger = LoggerFactory.getLogger(GcBidopenrecordSchedul.class);

    @Autowired
    private GcBidopenrecordService gcBidopenrecordService;

    @Autowired
    private AreaDataName areaDataName;

    @Autowired
    private TenderDetailsVoService tenderDetailsVoService;

    @Autowired
    private GcNoticeandfileService gcNoticeandfileService;


    @Autowired
    private ScheduledTashService scheduledTashService;

    @Autowired
    private GcAttachmentService gcAttachmentService;

    public void queryPageListUpdateEs() throws Exception {
        /**
         * 查询当前在定时任务表当中的最新时间
         */
        QueryWrapper<ScheduledTash> scheduledTashQueryWrapper = new QueryWrapper<ScheduledTash>();
        scheduledTashQueryWrapper.eq("table_name_value","gc_bidopenrecord");
        Page<ScheduledTash> pageScheduledTash = new Page<ScheduledTash>(1, 1);
        Page<ScheduledTash> page = scheduledTashService.page(pageScheduledTash, scheduledTashQueryWrapper);
        List<ScheduledTash> records = page.getRecords();
        ScheduledTash scheduledTash = null;
        if(records.size() > 0){
            scheduledTash = records.get(0);
        }
        Long time = null;
        if(ObjectUtils.isEmpty(scheduledTash)){
            try {
                /**
                 * 如果scheduledTash为空，证明没有当前定时任务，设置当前的定时任务的时间为0  查询表gcNoticeandfile表当中的最新时间
                 */
                time = gcBidopenrecordService.maxDataTimeStamp();
                ScheduledTash scheduledTashTash = new ScheduledTash();
                scheduledTashTash.setTime(0L);
                time = 0L;
                scheduledTashTash.setTableNameValue("gc_bidopenrecord");
                scheduledTashTash.setUpdateTime(new Date());
                scheduledTashTash.setCreateTime(new Date());
                scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
            }catch (Exception e){
                e.printStackTrace();
            }
        }else {
            /**
             * 如果scheduledTash为空，证明没有当前定时任务，设置当前的定时任务的时间为0  查询表gcNoticeandfile表当中的最新时间
             */
            time = scheduledTash.getTime();
        }
        try {
            //查询表gcNoticeandfile表当中的最新时间
            Long newTime = gcBidopenrecordService.maxDataTimeStamp();
            ScheduledTash scheduledTashTash = new ScheduledTash();
            scheduledTashTash.setTime(newTime);
            scheduledTashTash.setTableNameValue("gc_bidopenrecord");
            scheduledTashTash.setUpdateTime(new Date());
            scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
        }catch (Exception e){
            e.printStackTrace();
        }
        if(!ObjectUtils.isEmpty(time)){
            try {
                /**
                 * 查询表GcBidopenrecord表当中的最新时间，大于ScheduledTash当中的最新时间的数据
                 */
                QueryWrapper<GcBidopenrecord> GcBidopenrecordQueryWrapper = new QueryWrapper<GcBidopenrecord>();
                GcBidopenrecordQueryWrapper.gt("DATA_TIMESTAMP",time);
                int count = gcBidopenrecordService.count(GcBidopenrecordQueryWrapper);
                Integer pageSize = 1000;
                Integer pageNum = (int)Math.ceil((double)count/pageSize);
                for(int i = 1; i <= pageNum;i++){
                    try {
                        List<TenderDetailsVo> tenderDetailsVoListAll = getTenderDetailsVoListAll(i, pageSize,time);
                        gcNoticeandfileService.parseTenderDetailsVo(tenderDetailsVoListAll);
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
            }catch (Exception e){
                e.printStackTrace();
            }
        }
    }

    public List<TenderDetailsVo> getTenderDetailsVoListAll(Integer pageNo,Integer pageSize,Long time){
        Page<GcBidopenrecord> page = new Page<GcBidopenrecord>(pageNo, pageSize);
        IPage<TenderDetailsVo> pageList = gcBidopenrecordService.queryGcBidopenrecordAllListByTime(page,time);
        for (TenderDetailsVo record : pageList.getRecords()) {
            try {
                record.setNoticeTypeCode(ClassIfy.OPEN_RECORD.getCode());
                record.setNoticeTypeName(ClassIfy.OPEN_RECORD.getName());
                //电力交易
                if(!ObjectUtils.isEmpty(record.getSourceDataCode()) && "7089bc24".equals(record.getSourceDataCode())) {
                    record.setTransactionTypeCode(ClassIfy.ELECTRICITY.getCode());
                    record.setTransactionTypeName(ClassIfy.ELECTRICITY.getName());
                }else {
                    record.setTransactionTypeCode(ClassIfy.ENGINEERING_CONSTRUCTION.getCode());
                    record.setTransactionTypeName(ClassIfy.ENGINEERING_CONSTRUCTION.getName());
                }
                record = tenderDetailsVoService.getTenderDetailsVoAllOrther(record);

                /*try {
                    String bidSectionCodes = record.getBidSectionCodes();
                    int i1 = bidSectionCodes.indexOf(",");
                    int i2 = bidSectionCodes.indexOf(";");
                    int i3 = bidSectionCodes.indexOf("<br>");
                    int i4 = bidSectionCodes.indexOf("ltbrgt");
                    String splitBidSectionCode = null;
                    boolean flag = false;
                    String[] split = null;
                    if(i1 > 0){
                        split =  bidSectionCodes.split(",");
                        flag = true;
                    }
                    if(i2 > 0){
                        split =  bidSectionCodes.split(";");
                        flag = true;
                    }
                    if(i3 > 0){
                        split =  bidSectionCodes.split("<br>");
                        flag = true;
                    }
                    if(i4 > 0){
                        split =  bidSectionCodes.split("ltbrgt");
                        flag = true;
                    }
                    if(!flag){
                        split = new String[]{bidSectionCodes};
                    }
                    List<GcAttachment> attachmentList = new ArrayList<GcAttachment>();
                    if(record.getDataTimestamp()>20250324000000L){
                        //通过标包编号查询对应的附件信息
                        QueryWrapper<GcAttachment> gcAttachmentQueryWrapper = new QueryWrapper<GcAttachment>();
                        gcAttachmentQueryWrapper.eq("ATTACHMENT_SET_CODE","BID_RECORD_FILE");//add
                        gcAttachmentQueryWrapper.eq("ASSOCIATION_CODE", record.getSourceDataKey());
                        List<GcAttachment> list = gcAttachmentService.list(gcAttachmentQueryWrapper);

                        if(!ObjectUtils.isEmpty(list)){
                            attachmentList.addAll(list);
                        }
                    }else{
                        if(!ObjectUtils.isEmpty(split)){
                            if(split.length >=1){
                                for (String bidSectionCode : split) {
                                    try {
                                        //通过标包编号查询对应的附件信息
                                        QueryWrapper<GcAttachment> gcAttachmentQueryWrapper = new QueryWrapper<GcAttachment>();
                                        gcAttachmentQueryWrapper.eq("ATTACHMENT_SET_CODE","BID_RECORD_FILE");//add
                                        gcAttachmentQueryWrapper.like("BID_SECTION_CODE",bidSectionCode);
                                        List<GcAttachment> list = gcAttachmentService.list(gcAttachmentQueryWrapper);

                                        if(!ObjectUtils.isEmpty(list)){
                                            attachmentList.addAll(list);
                                        }
                                    }catch (Exception e){
                                        e.printStackTrace();
                                    }
                                }
                            }
                        }
                    }



                    String noticeContent = record.getNoticeContent();
                    String file = "";
                    if(!ObjectUtils.isEmpty(attachmentList)){
                        if(attachmentList.size() > 0){
                            file = "<br>附件：<br>";
                        }
                    }
                    for (GcAttachment gcAttachment : attachmentList) {
                        try{
                            String attachmentName = gcAttachment.getAttachmentName();
                            String url = gcAttachment.getUrl();
                            file += "<a  target='_blank' style='color: blue' href='"+ url +"'>"+ attachmentName +"</a><br/>";
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                    }
                    //招标文件拼接地址
                    if(!ObjectUtils.isEmpty(noticeContent) && noticeContent != ""){
                        file = noticeContent + file;
                    }
                    record.setNoticeContent(file);
                }catch (Exception e){
                    e.printStackTrace();
                }*/


                TenderDetailsVoUtils.isNull(record);
            }catch (Exception e){
                e.printStackTrace();
            }
        }
        return pageList.getRecords();
    }

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        try {
            if(JobLock.GcBidopenrecordFlag){
                JobLock.GcBidopenrecordFlag = false;
                logger.info("执行GcBidopenrecord", new SimpleDateFormat().format(new Date()));
                try {
                    queryPageListUpdateEs();
                } catch (Exception e) {
                    e.printStackTrace();
                }
                JobLock.GcBidopenrecordFlag = true;
            }else{
                logger.info("不执行GcBidopenrecord", new SimpleDateFormat().format(new Date()));
            }
        }catch (Exception e){
            e.printStackTrace();
            JobLock.GcBidopenrecordFlag = true;
        }
    }
}
