package com.trs.ggzyexchange.schedul;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.trs.ggzyexchange.entity.*;
import com.trs.ggzyexchange.enums.ClassIfy;
import com.trs.ggzyexchange.enums.JobLock;
import com.trs.ggzyexchange.service.*;
import com.trs.ggzyexchange.utils.TenderDetailsVoUtils;
import org.apache.commons.lang3.ObjectUtils;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Component
public class MarginReturnCeSchedul implements Job {

    @Autowired
    private ScheduledTashService scheduledTashService;

    @Autowired
    private TRegionService tRegionService;

    @Autowired
    private TenderDetailsVoService tenderDetailsVoService;

    @Autowired
    private AreaPlatformService areaPlatformService;

    @Autowired
    private MarginReturnCeService marginReturnCeService;

    @Autowired
    private GcNoticeandfileService gcNoticeandfileService;

    private Logger logger = LoggerFactory.getLogger(ZfcgGongao.class);

    public void queryPageListUpdateEs() throws JsonProcessingException {
        /**
         * 查询当前在定时任务表当中的最新时间
         */
        QueryWrapper<ScheduledTash> scheduledTashQueryWrapper = new QueryWrapper<ScheduledTash>();
        scheduledTashQueryWrapper.eq("table_name_value","margin_return_ce");
        Page<ScheduledTash> pageScheduledTash = new Page<ScheduledTash>(1, 1);
        Page<ScheduledTash> page = scheduledTashService.page(pageScheduledTash, scheduledTashQueryWrapper);
        List<ScheduledTash> records = page.getRecords();
        ScheduledTash scheduledTash = null;
        if(records.size() > 0){
            scheduledTash = records.get(0);
        }
        Long time = null;
        if(ObjectUtils.isEmpty(scheduledTash)){
            try {
                /**
                 * 如果scheduledTash为空，证明没有当前定时任务，设置当前的定时任务的时间为0  查询表gcNoticeandfile表当中的最新时间
                 */
                time = marginReturnCeService.maxDataTimeStamp();
                ScheduledTash scheduledTashTash = new ScheduledTash();
                scheduledTashTash.setTime(0L);
                time = 0L;
                scheduledTashTash.setTableNameValue("margin_return_ce");
                scheduledTashTash.setUpdateTime(new Date());
                scheduledTashTash.setCreateTime(new Date());
                scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
            }catch (Exception e){
                e.printStackTrace();
            }
        }else {
            /**
             * 如果scheduledTash为空，证明没有当前定时任务，设置当前的定时任务的时间为0  查询表gcNoticeandfile表当中的最新时间
             */
            time = scheduledTash.getTime();
        }
        try {
            //查询表gcNoticeandfile表当中的最新时间
            Long newTime = marginReturnCeService.maxDataTimeStamp();
            ScheduledTash scheduledTashTash = new ScheduledTash();
            scheduledTashTash.setTime(newTime);
            scheduledTashTash.setTableNameValue("margin_return_ce");
            scheduledTashTash.setUpdateTime(new Date());
            scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
        }catch (Exception e){
            e.printStackTrace();
        }

        if(!ObjectUtils.isEmpty(time)){
            try {
                QueryWrapper<MarginReturnCe> marginReturnCeQueryWrapper = new QueryWrapper<MarginReturnCe>();
                marginReturnCeQueryWrapper.gt("DATATIMESTAMP",time);
                int count = marginReturnCeService.count(marginReturnCeQueryWrapper);
                Integer pageSize = 1000;
                Integer pageNum = (int)Math.ceil((double)count/pageSize);
                for(int i = 1; i <= pageNum;i++){
                    try {
                        List<TenderDetailsVo> tenderDetailsVoListAll = getTenderDetailsVoListAll(i, pageSize,time);
                        Boolean aBoolean = gcNoticeandfileService.parseTenderDetailsVo(tenderDetailsVoListAll);
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
            }catch (Exception e){
                e.printStackTrace();
            }
        }
    }

    public List<TenderDetailsVo> getTenderDetailsVoListAll(Integer pageNo,Integer pageSize,Long time){
        QueryWrapper<MarginReturnCe> marginReturnCeQueryWrapper = new QueryWrapper<MarginReturnCe>();
        marginReturnCeQueryWrapper.gt("DATATIMESTAMP",time);
        Page<MarginReturnCe> page = new Page<MarginReturnCe>(pageNo, pageSize);
        Page<MarginReturnCe> page1 = marginReturnCeService.page(page,marginReturnCeQueryWrapper);
        List<MarginReturnCe> records = page1.getRecords();
        List<TenderDetailsVo> tenderDetailsVos = new ArrayList<TenderDetailsVo>();
        for (MarginReturnCe record : records) {
            TenderDetailsVo tenderDetailsVo = new TenderDetailsVo();
            String projectCode1 = record.getSectionCode();
            if(!ObjectUtils.isEmpty(projectCode1)){
                tenderDetailsVo.setProjectCode(projectCode1);
            }
            String noticeName = record.getBidderName();
            if(!ObjectUtils.isEmpty(noticeName)){
                tenderDetailsVo.setNoticeName(noticeName);
            }
            String projectName = record.getSectionCode();
            if(!ObjectUtils.isEmpty(projectName)){
                tenderDetailsVo.setProjectName(projectName);
            }
            String projectCode = record.getSectionCode();
            if(!ObjectUtils.isEmpty(projectCode)){
                tenderDetailsVo.setTenderProjectCode(projectCode);
            }

            if(!ObjectUtils.isEmpty(projectCode)){
                tenderDetailsVo.setBidSectionCodes(projectCode);
            }
            /*String noticeContent = record.getAnnouncementContent();
            if(!ObjectUtils.isEmpty(noticeContent)){
                tenderDetailsVo.setNoticeContent(noticeContent);
            }*/
            String noticeContent = "";
            String refundState = record.getRefundState();
            if(!"1".equals(refundState)){
                noticeContent = "退款状态：已退";
            }else {
                noticeContent = "退款状态：未退";
            }
            tenderDetailsVo.setNoticeContent(noticeContent);
            Long noticeSendTime = record.getDatatimestamp();
            if(!ObjectUtils.isEmpty(noticeSendTime)){
                tenderDetailsVo.setNoticeSendTime(noticeSendTime.toString());
            }

            String dataSourceCode = record.getSourceDataCode();
            if(!ObjectUtils.isEmpty(dataSourceCode)){
                tenderDetailsVo.setDataSourceCode(dataSourceCode);
                switch (dataSourceCode){
                    case "2010":
                        tenderDetailsVo.setPlatformCode("121500004600236091");//内蒙古自治区本级
                        break;
                    case "3010":
                        tenderDetailsVo.setPlatformCode("11150100MB1E47030G");//呼和浩特市
                        break;
                    case "4010":
                        tenderDetailsVo.setPlatformCode("12150200MB0U60369T");//包头市
                        break;
                    case "9010":
                        tenderDetailsVo.setPlatformCode("12150300764460701U");//乌海市
                        break;
                    case "10010":
                        tenderDetailsVo.setPlatformCode("12150400752562129C");//赤峰市
                        break;
                    case "12010":
                        tenderDetailsVo.setPlatformCode("12150500767870933F");//通辽市
                        break;
                    case "6010":
                        tenderDetailsVo.setPlatformCode("12152100318426562M");//呼伦贝尔市
                        break;
                    case "15010":
                        tenderDetailsVo.setPlatformCode("12152102756670143N");//满洲里市
                        break;
                    case "8010":
                        tenderDetailsVo.setPlatformCode("121522003413773750");//兴安盟
                        break;
                    case "7010":
                        tenderDetailsVo.setPlatformCode("121525007610874707");//锡林郭勒盟
                        break;
                    case "16010":
                        tenderDetailsVo.setPlatformCode("12152501MB1H44166N");//二连浩特市
                        break;
                    case "11010":
                        tenderDetailsVo.setPlatformCode("12152600MB0W03964L");//乌兰察布市
                        break;
                    case "5010":
                        tenderDetailsVo.setPlatformCode("121527005919547886");//鄂尔多斯市
                        break;
                    case "13010":
                        tenderDetailsVo.setPlatformCode("1215280046118106XX");//巴彦淖尔市
                        break;
                    case "14010":
                        tenderDetailsVo.setPlatformCode("12152900085184725H");//阿拉善盟
                        break;
                }
            }
            String sourceDataKey = record.getSourceDataKey();
            if(!ObjectUtils.isEmpty(sourceDataKey)){
                tenderDetailsVo.setSourceDataKey(sourceDataKey+noticeSendTime);
            }

            tenderDetailsVos.add(tenderDetailsVo);
        }
        for (TenderDetailsVo record : tenderDetailsVos) {
            try {
                record.setNoticeTypeCode(ClassIfy.MARGIN_RETURN_CE.getCode());
                record.setNoticeTypeName(ClassIfy.MARGIN_RETURN_CE.getName());
                record.setTransactionTypeCode(ClassIfy.ENGINEERING_CONSTRUCTION.getCode());
                record.setTransactionTypeName(ClassIfy.ENGINEERING_CONSTRUCTION.getName());
                record = tenderDetailsVoService.getTenderDetailsVoAllOrther(record);
                TenderDetailsVoUtils.isNull(record);
            }catch (Exception e){
                e.printStackTrace();
            }
        }
        return tenderDetailsVos;
    }

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        try {
            if(JobLock.MarginReturnCeFlag){
                JobLock.MarginReturnCeFlag = false;
                logger.info("MarginReturnCeFlag", new SimpleDateFormat().format(new Date()));
                try {
                    queryPageListUpdateEs();
                } catch (Exception e) {
                    e.printStackTrace();
                }
                JobLock.MarginReturnCeFlag = true;
            }else{
                logger.info("MarginReturnCeFlag", new SimpleDateFormat().format(new Date()));
            }
        }catch (Exception e){
            e.printStackTrace();
            JobLock.MarginReturnCeFlag = true;
        }
    }
}

