package com.trs.ggzyexchange.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.trs.ggzyexchange.entity.NmNotice;
import com.trs.ggzyexchange.entity.TenderDetailsVo;
import com.trs.ggzyexchange.mapper.NmNoticeMapper;
import com.trs.ggzyexchange.service.NmNoticeService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author trs
 * @since 2024-02-27
 */
@Service
public class NmNoticeServiceImpl extends ServiceImpl<NmNoticeMapper, NmNotice> implements NmNoticeService {

    @Autowired
    private NmNoticeMapper nmNoticeMapper;


    @Override
    public IPage<TenderDetailsVo> queryNmNoticeAllListByTime(Page<NmNotice> page, Long time) {
        return nmNoticeMapper.queryNmNoticeAllListByTime(page,time);
    }

    @Override
    public Long maxDataTimeStamp() {
        Long aLong = nmNoticeMapper.maxDataTimeStamp();
        try{
            if(!ObjectUtils.isEmpty(aLong)){
                if(aLong != 0){
                    String sLong = ((aLong+"").substring(0,8)) + "000000";
                    aLong = Long.parseLong(sLong);
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        return aLong;
    }

}
