package com.trs.ggzyexchange.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.trs.ggzyexchange.entity.GcTenderbidfile;
import com.trs.ggzyexchange.entity.NmResultNotice;
import com.trs.ggzyexchange.entity.TenderDetailsVo;
import com.trs.ggzyexchange.mapper.NmResultNoticeMapper;
import com.trs.ggzyexchange.service.NmResultNoticeService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author trs
 * @since 2024-02-27
 */
@Service
public class NmResultNoticeServiceImpl extends ServiceImpl<NmResultNoticeMapper, NmResultNotice> implements NmResultNoticeService {

    @Autowired
    private NmResultNoticeMapper nmResultNoticeMapper;

    @Override
    public IPage<TenderDetailsVo> queryNmResultNoticeAllListByTime(Page<GcTenderbidfile> page, Long time) {
        return nmResultNoticeMapper.queryNmResultNoticeAllListByTime(page,time);
    }

    @Override
    public Long maxDataTimeStamp() {
        Long aLong = nmResultNoticeMapper.maxDataTimeStamp();
        try{
            if(!ObjectUtils.isEmpty(aLong)){
                if(aLong != 0){
                    String sLong = ((aLong+"").substring(0,8)) + "000000";
                    aLong = Long.parseLong(sLong);
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        return aLong;
    }


}
