package com.trs.ggzyexchange.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.trs.ggzyexchange.entity.GcTenderbidfile;
import com.trs.ggzyexchange.entity.TenderDetailsVo;
import com.trs.ggzyexchange.entity.YcNotice;
import com.trs.ggzyexchange.mapper.YcNoticeMapper;
import com.trs.ggzyexchange.service.YcNoticeService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.Data;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Calendar;
import java.util.Date;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author trs
 * @since 2023-12-18
 */
@Service
public class YcNoticeServiceImpl extends ServiceImpl<YcNoticeMapper, YcNotice> implements YcNoticeService {

    @Autowired
    private YcNoticeMapper ycNoticeMapper;

    @Override
    public Long maxDataTimeStamp() {
        Long aLong = ycNoticeMapper.maxDataTimeStamp();
        Date date = new Date(aLong);
        // 使用 Calendar 实现
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        calendar.set(Calendar.HOUR_OF_DAY, 0);
        calendar.set(Calendar.MINUTE, 0);
        calendar.set(Calendar.SECOND, 0);
        calendar.set(Calendar.MILLISECOND, 0);
        Date startOfDay = calendar.getTime();
        return startOfDay.getTime();
    }

    @Override
    public IPage<TenderDetailsVo> queryYcNoticeAllListByTime(Page<GcTenderbidfile> page, Long time) {
        return ycNoticeMapper.queryYcNoticeAllListByTime(page,time);
    }
}
