package com.trs.ggzyexchange.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.trs.ggzyexchange.entity.ZfcgGongao;
import com.trs.ggzyexchange.entity.TenderDetailsVo;
import com.trs.ggzyexchange.mapper.ZfcgGongaoMapper;
import com.trs.ggzyexchange.service.ZfcgGongaoService;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author trs
 * @since 2024-02-27
 */
@Service
public class ZfcgGongaoServiceImpl extends ServiceImpl<ZfcgGongaoMapper, ZfcgGongao> implements ZfcgGongaoService {

    @Autowired
    private ZfcgGongaoMapper zfcgGongaoMapper;


    public IPage<TenderDetailsVo> queryZfcgGongaoListByTime(Page<ZfcgGongao> page, Long time) {
        return zfcgGongaoMapper.queryZfcgGongaoListByTime(page,time);
    }

    public Long maxDataTimeStamp() {
        Long aLong = zfcgGongaoMapper.maxDataTimeStamp();
        try{
            if(!ObjectUtils.isEmpty(aLong)){
                if(aLong != 0){
                    String sLong = ((aLong+"").substring(0,8)) + "000000";
                    aLong = Long.parseLong(sLong);
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        return aLong;
    }

}
